Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /sml/trunk/config/install.sh
ViewVC logotype

Diff of /sml/trunk/config/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 249, Sat Apr 17 18:57:03 1999 UTC sml/trunk/config/install.sh revision 1672, Thu Oct 28 15:44:02 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/sh
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4    # Copyright (c) 2003 The Fellowship of SML/NJ
5  #  #
6  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
7  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
8  #  #
9    # Significant changes to take advantage of a new portable installer
10  #set -x  # script for everything after booting the interactive system.
   
11  #  #
12  # get the target list  # Author: Matthias Blume (blume@tti-c.org)
13  #  #
14  if [ ! -r config/targets ]; then  
15    echo "!!! no target list"  if [ x${INSTALL_QUIETLY} = xtrue ] ; then
16    exit 1;      export CM_VERBOSE
17        CM_VERBOSE=false
18  fi  fi
 . config/targets  
19    
20  #  vsay() {
21  # some OSs have make in strange places      if [ x${INSTALL_DEBUG} = xtrue ] ; then
22  #          echo "$@"
23  MAKE=make      elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
24            :
25        else
26            echo "$@"
27        fi
28    }
29    
30    complain() {
31        echo "$@"
32        exit 1
33    }
34    
35    this=$0
36    
37    
38  #  #
39  # command for building SML libraries; this should be either  # create the preloads.standard file
 # "CM.recompile()" or "CM.stabilize true".  The latter builds  
 # stable libraries, which may be somewhat faster to use.  
40  #  #
41  #CM_MAKE_LIB="CM.recompile();"  if [ ! -r config/preloads ]; then
42  CM_MAKE_LIB="CM.stabilize true;"      complain "$this: !!! File config/preloads is missing."
43    fi
44    cp config/preloads preloads.standard
45    
46  #  #
47  # check for ksh  # Some OSs have make in strange places, but most of the time it is
48  #  # simply on the PATH:
 # ksh causes some people problems so we will always use /bin/sh  
49  #  #
50  #echo "checking for ksh"  MAKE=make
51  #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
52    SHELL=/bin/sh    SHELL=/bin/sh
53  #fi  vsay $this: Using shell $SHELL.
 echo "  using $SHELL"  
54    
55  #  #
56  # set the SML root directory  # set the SML root directory
57  #  #
58  REAL_PWD=`pwd`  REAL_PWD=`pwd`
59  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
60  echo "SML root is $ROOT"  vsay $this: SML root is $ROOT.
61    
62    cd ${INSTALLDIR:=$ROOT}
63    INSTALLDIR=`pwd`
64    cd $ROOT
65    vsay $this: Installation directory is ${INSTALLDIR}.
66    
67  #  #
68  # set the various directory pathname variables  # set the various directory and file pathname variables
69  #  #
70  BINDIR=$ROOT/bin  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
71  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
72  HEAPDIR=$BINDIR/.heap  HEAPDIR=$BINDIR/.heap           # where heap images live
73  RUNDIR=$BINDIR/.run  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
74  SRCDIR=$ROOT/src  SRCDIR=$ROOT/src                # where the source tree is rooted
75  LIBDIR=$ROOT/lib  LIBDIR=$INSTALLDIR/lib          # where libraries live
76    
77  #  #
78  # the paths to ml-yacc and ml-lex; needed to configure CM  # files to be deleted after we are done...
79    #
80    tmpfiles=""
81    tmpfiles="$tmpfiles $ROOT/preloads.standard"
82    #
83    # make sure we always clean up after ourselves...
84  #  #
85  YACCPATH=$BINDIR/ml-yacc  trap 'rm -f $tmpfiles' 0 1 2 3 15
86  LEXPATH=$BINDIR/ml-lex  
 BURGPATH=$BINDIR/ml-burg  
87    
88  #  #
89  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
90  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
91  #  -M.Blume (5/1998)  # Especially important is CM_PATHCONFIG.
92  #  #
93  CM_YACC_DEFAULT=$YACCPATH  export CM_PATHCONFIG
94  CM_LEX_DEFAULT=$LEXPATH  CM_PATHCONFIG=$LIBDIR/pathconfig
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATH_DEFAULT=.:$LIBDIR  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATH_DEFAULT  
95    
96  #  #
97  # the release version that we are installing  # the release version that we are installing
98  #  #
99  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
100  echo "installing version $VERSION"  vsay $this: Installing version $VERSION.
101    
102  #  #
103  # create the various sub directories  # the URL for the (usually remote) source archive
104  #  #
105  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  . $CONFIGDIR/srcarchiveurl
106  do  vsay $this: URL of source archive is $SRCARCHIVEURL.
107    if [ -d $dir ]; then  
108      echo "$dir already exists"  #
109    else  # Function to make a directory including its ancestors.
110      echo "creating $dir"  #
111      mkdir $dir  makedir() {
112      if [ $? != "0" ]; then      if [ x$1 = x ] ; then
113        echo "unable to create $dir"          :
114        exit 1      elif [ -d $1 ] ; then
115            :
116        else
117            makedir `dirname $1`
118            if [ x${INSTALL_VERBOSE} = xtrue ] ; then
119                vsay "$this: Making directory $1"
120      fi      fi
121            if mkdir $1 ; then
122                :
123            else
124                complain "$this: !!! Unable to make directory $1!"
125    fi    fi
126  done      fi
127    }
128    
129  #  #
130  # install the script that tests the architecture, and make sure that it works  # Fish out the CM metadata directory name from library files
131    # and store it in ORIG_CM_DIR_ARC.
132    # The single argument is the name of the directory containing
133    # a single subdirectory which is a CM metadata directory:
134  #  #
135  if [ -x $BINDIR/.arch-n-opsys ]; then  fish() {
136    echo "$BINDIR/.arch-n-opsys already exists"      cd $1
137        ORIG_CM_DIR_ARC=unknown
138        for i in * .[a-zA-Z0-9]* ; do
139            if [ -d $i ] ; then
140                ORIG_CM_DIR_ARC=$i
141                break
142            fi
143        done
144        if [ $ORIG_CM_DIR_ARC = unknown ] ; then
145            complain "$this: could not determine CM metadata directory name"
146  else  else
147    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys          echo "$this: CM metadata directory name is \"${ORIG_CM_DIR_ARC}\""
148    chmod 555 $BINDIR/.arch-n-opsys      fi
149    if [ ! -x $BINDIR/.arch-n-opsys ]; then  }
150      echo "!!! installation of $BINDIR/.arch-n-opsys failed for some reason"  
151      exit 1  
152    # A function to move all stable library files to a parallel directory
153    # hierarchy.
154    # The first argument must be a simple path (no / inside), and
155    # the second argument must be an absolute path.
156    move() {
157        if [ -L $1 ] ; then
158            rm -f $1             # remove symbolic link made by diracs (see below)
159        elif [ -d $1 ] ; then
160            if [ ! -d $2 ] ; then
161                if [ -f $2 ] ; then
162                    complain $this: $2 exists as a non-directory.
163                fi
164                mkdir $2
165            fi
166            cd $1
167            for i in * .[a-zA-Z0-9]* ; do
168                move $i $2/$i
169            done
170            cd ..
171        elif [ -f $1 ] ; then
172            rm -f $2
173            mv $1 $2
174        fi
175    }
176    
177    #
178    # Traverse the directory tree rooted at $3 (must be single arc!).
179    # Find all directories named $1, rename them into $2 and make
180    # and establish $1 as a symbolic link to $2:
181    #
182    dirarcs() {
183        if [ -d $3 ] ; then
184            if [ $3 = $1 ] ; then
185                mv $1 $2
186                ln -s $2 $1
187            else
188                cd $3
189                for d in * .[a-zA-Z0-9]* ; do
190                    dirarcs $1 $2 $d
191                done
192                cd ..
193    fi    fi
194  fi  fi
195    }
196    
197    
198    ######################################################################
199    
200    #
201    # create the various sub directories
202    #
203    for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
204        makedir $dir
205    done
206    
207    #
208    # Function to install a "driver" script...
209    #   This takes care of patching the source of the script with the SHELL,
210    #   BINDIR, and VERSION variables to use.
211    #
212    installdriver() {
213        dsrc=$1
214        ddst=$2
215    # We install the driver unconditionally. (It would be better to test
216    # for an outdated driver script, but not all "test" commands understand
217    # the -nt comparison operator....)
218    #   if [ -x $BINDIR/$ddst ]; then
219    #       echo $this: Script $BINDIR/$ddst already exists.
220    #   else
221            rm -f $BINDIR/$ddst
222            cat $CONFIGDIR/$dsrc | \
223            sed -e "s,@SHELL@,$SHELL,g" \
224                -e "s,@BINDIR@,$BINDIR," \
225                -e "s,@VERSION@,$VERSION," \
226                -e "s,@CMDIRARC@,${CM_DIR_ARC:-dummy}," \
227                > $BINDIR/$ddst
228            chmod 555 $BINDIR/$ddst
229            if [ ! -x $BINDIR/$ddst ]; then
230                complain "$this: !!! Installation of $BINDIR/${ddst} failed."
231            fi
232    #   fi
233    }
234    
235    #
236    # install the script that tests architecture and os...
237    #
238    installdriver _arch-n-opsys .arch-n-opsys
239    
240    #
241    # run it to figure out what architecture and os we are using, define
242    # corresponding variables...
243    #
244  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
245  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
246    echo "!!! $BINDIR/.arch-n-opsys fails on this machine"      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
247    echo "!!! you must patch this by hand and repeat the installation"      echo "$this: !!! You must patch this by hand and repeat the installation."
248    exit 2    exit 2
249  else  else
250    echo "$BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS"      vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
251  fi  fi
252  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
253    
254  if [ -x $BINDIR/.run-sml ]; then  #
255    echo "$BINDIR/.run-sml already exists"  # now install most of the other driver scripts
256  else  #  (except ml-build, since we don't know $CM_DIR_ARC yet)
257    cat $CONFIGDIR/_run-sml | \  #
258      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  installdriver _run-sml .run-sml
259      > $BINDIR/.run-sml  installdriver _link-sml .link-sml
260    chmod 555 $BINDIR/.run-sml  installdriver _ml-makedepend ml-makedepend
   if [ ! -x $BINDIR/.run-sml ]; then  
     echo "!!! installation of $BINDIR/.run-sml failed for some reason"  
     exit 1  
   fi  
 fi  
261    
262  #  #
263  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
264  #  #
265  case $ARCH in  case $ARCH in
266    mips*) ALLOC=1M ;;      mips*)
267            ALLOC=1M
268            ;;
269    x86)    x86)
270            # The following is the _wrong_ value for many popular x86 chips
271            # (i.e., Celerons).  However, the optimal value for those is 32k,
272            # and such a small value is not enough for the runtime system's boot
273            # code.  Therefore, we use 256k here and re-set it to the proper
274            # value in .run-sml.
275      ALLOC=256k      ALLOC=256k
276    ;;    ;;
277    alpha32)    alpha32)
# Line 155  Line 281 
281      ALLOC=512k      ALLOC=512k
282    ;;    ;;
283  esac  esac
284    
285  case $OPSYS in  case $OPSYS in
286    solaris)    solaris)
287      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 162  Line 289 
289    linux)    linux)
290      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
291      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
292        echo "problems checking for underscores in global names"              complain "$this: !!! Problems checking for underscores in asm names."
       exit 1  
293      fi      fi
294      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
295    ;;    ;;
# Line 172  Line 298 
298  #  #
299  # the name of the bin files directory  # the name of the bin files directory
300  #  #
301  BIN_FILES=bin.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
302    BOOT_FILES=sml.$BOOT_ARCHIVE
303    
304  #  #
305  # build the run-time system  # build the run-time system
306  #  #
307  $CONFIGDIR/unpack.sh "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime.tar  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
308  if [ "$?" != "0" ]; then      vsay $this: Run-time system already exists.
309    exit $?  else
310  fi      $CONFIGDIR/unpack $ROOT runtime
 if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  
311    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
312    echo "compiling the run-time system"      echo $this: Compiling the run-time system.
313    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
314    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
315      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
316      $MAKE MAKE=$MAKE clean      $MAKE MAKE=$MAKE clean
317    else    else
318      echo "!!! run-time system build failed for some reason"          complain "$this: !!! Run-time system build failed for some reason."
     exit 1  
319    fi    fi
320  fi  fi
321  cd $SRCDIR  cd $SRCDIR
# Line 199  Line 324 
324  # boot the base SML system  # boot the base SML system
325  #  #
326  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
327    echo "$HEAPDIR/sml.$HEAP_SUFFIX already exists"      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
328        fish $LIBDIR/basis.cm
329        # ignore requested arc name since we have to live with what is there:
330        export CM_DIR_ARC
331        CM_DIR_ARC=$ORIG_CM_DIR_ARC
332  else  else
333    $CONFIGDIR/unpack.sh bin $ROOT $BIN_FILES $ROOT/$VERSION-$BIN_FILES.tar      $CONFIGDIR/unpack $ROOT $BOOT_ARCHIVE
334    
335        fish $ROOT/$BOOT_FILES/basis.cm
336    
337    cd $ROOT    cd $ROOT
338    $RUNDIR/run.$ARCH-$OPSYS @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
339      $SET_FLAGS      # Target arc:
340      val use = Compiler.Interact.useFile      export CM_DIR_ARC
341      val _ = (SMLofNJ.exportML "sml";      CM_DIR_ARC=${CM_DIR_ARC:-".cm"}
342               print Compiler.banner;  
343               print "\n");      if [ $CM_DIR_ARC = $ORIG_CM_DIR_ARC ] ; then
344  XXXX          : we are happy
   if [ -r sml.$HEAP_SUFFIX ]; then  
     mv sml.$HEAP_SUFFIX $HEAPDIR  
     cd $BINDIR  
     ln -s .run-sml sml  
345    else    else
346      echo "!!! unable to build SML heap image (sml.$HEAP_SUFFIX)"          # now we have to make a symbolic link for each occurrence of
347      exit 1          # $ORIG_CM_DIR_ARC to $CM_DIR_ARC
348    fi          dirarcs ${ORIG_CM_DIR_ARC} ${CM_DIR_ARC} $BOOT_FILES
349  fi  fi
350    
351        cd $ROOT/$BOOT_FILES
352    
353        # now link (boot) the system and let it initialize itself...
354        if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
355        then
356            cd $ROOT
357            if [ -r sml.$HEAP_SUFFIX ]; then
358                mv sml.$HEAP_SUFFIX $HEAPDIR
359                cd $BINDIR
360                ln -s .run-sml sml
361  #  #
362  # now build the individual targets              # Now move all stable libraries to #LIBDIR and generate
363                # the pathconfig file.
364  #  #
365  cd $SRCDIR              cd $ROOT/$BOOT_FILES
366  echo "install targets"              for anchor in * ; do
367  for i in $TARGETS                  if [ -d $anchor ] ; then
368  do                      echo $anchor $anchor >>$CM_PATHCONFIG
369    if [ $i = "doc" ]; then                      move $anchor $LIBDIR/$anchor
370      TARGET=$i                  fi
   else  
     TARGET=$i.$HEAP_SUFFIX  
   fi  
   if [ -r $HEAPDIR/$TARGET ]; then  
     echo "$TARGET already exists"  
   else  
     echo "  building $TARGET"  
     case $i in  
       src-smlnj)  
         for src in compiler comp-lib cm MLRISC; do  
           $CONFIGDIR/unpack.sh $src $ROOT/src $src $ROOT/$VERSION-$src.tar  
371          done          done
       ;;  
       sml-full)  
         if [ ! -d $ROOT/$BIN_FILES ]; then  
           echo "!!! bin files are missing; build of $TARGET failed"  
           exit 1  
         else  
372            cd $ROOT            cd $ROOT
373            $RUNDIR/run.$ARCH-$OPSYS @SMLfull @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
374              $SET_FLAGS              rm -rf $BOOT_FILES
375              val use = Compiler.Interact.useFile  
             val _ = (SMLofNJ.exportML "sml-full";  
                      print Compiler.banner;  
                      print " [full]\n");  
 XXXX  
           if [ -r sml-full.$HEAP_SUFFIX ]; then  
             mv sml-full.$HEAP_SUFFIX $HEAPDIR  
             cd $BINDIR  
             ln -s .run-sml sml-full  
           else  
             echo "!!! unable to build SML-FULL heap image"  
             exit 1  
           fi  
         fi  
       ;;  
       ml-yacc)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc  
         ./build  
         if [ -r src/$TARGET ]; then  
           mv src/$TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
       ;;  
       ml-lex)  
         $CONFIGDIR/unpack.sh ML-Lex $SRCDIR ml-lex $ROOT/$VERSION-ml-lex.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-lex  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
376          else          else
377            echo "!!! build of $TARGET failed"              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
           exit 1  
         fi  
       ;;  
       ml-burg)  
         $CONFIGDIR/unpack.sh ML-Burg $SRCDIR ml-burg $ROOT/$VERSION-ml-burg.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-burg  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
378            fi            fi
379          else          else
380            echo "!!! build of $TARGET failed"          complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
           exit 1  
         fi  
       ;;  
       smlnj-lib)  
         $CONFIGDIR/unpack.sh "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
       # make the Util library  
         cd $SRCDIR/smlnj-lib/Util  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/smlnj-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Util/sources.cm" > smlnj-lib.cm  
         fi  
       # make the Unix library  
         cd $SRCDIR/smlnj-lib/Unix  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/unix-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Unix/sources.cm" > unix-lib.cm  
         fi  
       # make the HTML library  
         cd $SRCDIR/smlnj-lib/HTML  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/html-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/HTML/sources.cm" > html-lib.cm  
         fi  
       # make the Reactive library  
         cd $SRCDIR/smlnj-lib/Reactive  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/reactive-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Reactive/sources.cm" > reactive-lib.cm  
         fi  
       # make the PP library  
         cd $SRCDIR/smlnj-lib/PP  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/pp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/PP/sources.cm" > pp-lib.cm  
         fi  
       # make the RegExp library  
         cd $SRCDIR/smlnj-lib/RegExp  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/regexp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/RegExp/sources.cm" > regexp-lib.cm  
         fi  
       ;;  
       ml-yacc-lib)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc/lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/ml-yacc-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/ml-yacc/lib/sources.cm" > ml-yacc-lib.cm  
         fi  
       ;;  
       cml)  
         $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
381          fi          fi
         cd $SRCDIR/cml/src  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/src/sources.cm" > cml.cm  
382          fi          fi
       ;;  
       cml-lib)  
         $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/cml/cml-lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/cml-lib/sources.cm" > cml-lib.cm  
         fi  
       ;;  
       cml-cm)  
         CMD="CM.autoloading(SOME true); CM.clearAutoList();"  
         CMD="$CMD CM.autoload'(\"$LIBDIR/cml.cm\");"  
         if [ "$AUTOLOAD_CML_LIB" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/cml-lib.cm\");"  
         fi  
         if [ "$AUTOLOAD_EXENE" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/eXene.cm\");"  
         fi  
         cd $ROOT  
         $BINDIR/sml <<XXXX  
           $CMD  
           val _ = (SMLofNJ.exportML "$i";  
                 print CML.banner;  
                 print "[CML autoload]\n");  
 XXXX  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! unable to build autoloading CML"  
           exit 1  
         fi  
       ;;  
       eXene)  
         $CONFIGDIR/unpack.sh EXene $SRCDIR eXene $ROOT/$VERSION-eXene.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/eXene  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/eXene.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/eXene/sources.cm" > eXene.cm  
         fi  
       ;;  
       doc)  
         $CONFIGDIR/unpack.sh Doc $ROOT doc $ROOT/$VERSION-doc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $ROOT/doc  
         build $ROOT  
       ;;  
       *)  
         echo "!!! unknown target $i"  
       ;;  
     esac  
   fi  
 done  
383    
384  if [ "$ENABLE_AUTOLOADING" = "TRUE" ]; then  #
385    CMD="CM.autoloading(SOME true); CM.clearAutoList();"  # now that we know CM_DIR_ARC we can install the ml-build driver...
386    if [ "$AUTOLOAD_SMLNJ_LIB" = "TRUE" ]; then  #
387      CMD="$CMD CM.autoload'(\"$LIBDIR/smlnj-lib.cm\");"  installdriver _ml-build ml-build
388    fi  
   if [ "$AUTOLOAD_SMLNJ_UNIX" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/unix-lib.cm\");"  
   fi  
   if [ "$AUTOLOAD_SMLNJ_HTML" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/html-lib.cm\");"  
   fi  
   if [ "$AUTOLOAD_SMLNJ_REACTIVE" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/reactive-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_PP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/pp-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_REGEXP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/regexp-lib.cm\");"  
   fi  
389    cd $ROOT    cd $ROOT
390    $BINDIR/sml <<XXXX  
391      $CMD  #
392      val _ = (SMLofNJ.exportML "sml";  # Now do all the rest using the precompiled installer:
393               print Compiler.banner;  #
394               print " [CM; autoload enabled]\n");  echo $this: Installing other libraries and programs:
395  XXXX  export ROOT INSTALLDIR CONFIGDIR BINDIR
396    if [ -r sml.$HEAP_SUFFIX ]; then  if $BINDIR/sml -m \$smlnj/installer.cm
397      mv sml.$HEAP_SUFFIX $HEAPDIR  then
398        vsay $this: Installation complete.
399    else    else
400      echo "!!! unable to build SML with autoloading"      complain "$this: !!! Installation of libraries and programs failed."
     exit 1  
   fi  
401  fi  fi
402    
403    exit 0

Legend:
Removed from v.249  
changed lines
  Added in v.1672

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0